<?php
namespace Claromentis\People;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"] = (@$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] ?: array()) + array("_e02488992f8c" . "e86b71d9f32b2" . "9fe215c" => base64_decode("SU5TRVJUIElOVE8gb3JnX2NoYXJ0IChpZCwgYm9zc19pZCwgaXNfcHJpbWFyeSkgVkFMVUVTIChpbnQ6dWlkLC" . "BpbnQ6bWFuYWdlcl9pZCwgMSk="), "_88aa4158bbda1ad77d138780ea" . "68e38b" => base64_decode("U0VMRUNUIGlkLCBpc19wcmltYXJ5IEZST00gb3JnX2NoYXJ0IFdIRVJFIGJvc3NfaWQ9aW50OnV" . "pZA=="), "_2f700090654ea4" . "3a4fec1f8ca5084" . "d38" => base64_decode("REVMRVRFIEZST00gb3JnX2NoYXJ0IFdIRVJFIGJvc3NfaWQ9aW50OnVp" . "ZA=="), "_62d701c3c534" . "04f06345eb357" . "20a47b4" => base64_decode("aXNfbnVtZXJpYw=" . "="), "_680cc2b8" . "220e94c8c" . "32b8bc7c6" . "5519b4" => base64_decode("aXNfa" . "W50"), "_98966bfaaccbeb4658" . "a87a97e8fafb11" => base64_decode("REVMRVRFIEZST00gb3JnX2NoYXJ0IFdIRVJFI" . "GlkPWludDp1aWQ="), "_736432b3f9e1cd2ec77" . "cd6f2ba0c3bdb" => base64_decode("U0VMRUNUIGJvc3NfaWQgRlJPTSBvcm" . "dfY2hhcnQgV0hFUkUgaWQ9aW50OnVp" . "ZCBBTkQgYm9zc19pZDw+aW50OnVpZC" . "BPUkRFUiBCWSBpc19wcmltYXJ5"), "_7f628626dd1d55c71b1f" . "c0932ffd1d2c" => base64_decode("aXN" . "fYX" . "JyY" . "Xk="));
use Claromentis\Core\DAL\Interfaces\DbInterface;







class UsersHierarchyService
{
    
    
    
    
    protected $db;
    public function __construct(DbInterface $db)
    {
        $this->db = $db;
    }
    
    
    
    
    
    
    
    
    public function SetManager($user_id, $_b324f64f5346fe6cd20483e208d94430) : bool
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_62d701c3c53404f0634" . "5eb35720a47b4"]($user_id) || !$user_id) {
            return false;
        }
        
        
        $this->db->query($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_98966bfaaccbeb46" . "58a87a97e8fafb11"], $user_id);
        if ($_b324f64f5346fe6cd20483e208d94430 === null) {
            return true;
        }
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_680cc2b8220e94c8c32b8bc7c65519" . "b4"]($_b324f64f5346fe6cd20483e208d94430)) {
            return false;
        }
        $this->db->query($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_e02488992f8ce86b" . "71d9f32b29fe215c"], $user_id, $_b324f64f5346fe6cd20483e208d94430);
        return true;
    }
    
    
    
    
    
    
    
    public function SetSubordinates($user_id, $_9b25bd1f846ab3177a43069b54248349)
    {
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_2f700090654ea43a4fec1f8" . "ca5084d38"], $user_id);
        
        
        if (!$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_7f628626dd1d55c71" . "b1fc0932ffd1d2c"]($_9b25bd1f846ab3177a43069b54248349)) {
            return false;
        }
        
        
        foreach ($_9b25bd1f846ab3177a43069b54248349 as $_f19d55a3cc79997bcb33f250cc2ee482) {
            if (!$this->SetManager($_f19d55a3cc79997bcb33f250cc2ee482, $user_id)) {
                return false;
            }
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetManager($user_id)
    {
        list($_b324f64f5346fe6cd20483e208d94430) = $this->db->query_row($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_736432b3f9e1cd2ec" . "77cd6f2ba0c3bdb"], $user_id, $user_id);
        return $_b324f64f5346fe6cd20483e208d94430 ?? 0;
    }
    
    
    
    
    
    
    
    public function GetSubordinates($user_id)
    {
        $_189840d11056515e52402d1412a0b6e4 = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_88aa4158bbda1ad" . "77d138780ea68e38" . "b"], $user_id);
        $_5bbedf94f4628faff30d9e300695d342 = array();
        while ($row = $_189840d11056515e52402d1412a0b6e4->fetchRow()) {
            if (!$row[1] && self::GetManager($row[0]) != $user_id) {
                continue;
            }
            $_5bbedf94f4628faff30d9e300695d342[] = $row[0];
        }
        return $_5bbedf94f4628faff30d9e300695d342;
    }
}